﻿using System;
using System.Threading;

delegate int Dodaj(int x, ref int y);

public sealed class App
{
    static public int zbroji(int x, ref int y)
    {
        Console.WriteLine("Dodavanje");
        return x + y++;
    }

    public int oduzmi(int x, ref int y)
    {
        Console.WriteLine("Oduzimanje");
        Thread.Sleep(1000);
        return x - y++;
    }

    static void Main()
    {
        Dodaj d = new Dodaj(zbroji);
        int y = 10;
        Console.WriteLine(d.Invoke(10, ref y));
        Console.WriteLine(y);

        App a = new App();
        Dodaj o = new Dodaj(a.oduzmi);

        IAsyncResult ar = o.BeginInvoke(10, ref y, null, null);

        //if (!ar.CompletedSynchronously)
        //    while (!ar.IsCompleted)
        //        Thread.Sleep(1);

        //ar.AsyncWaitHandle.WaitOne();

        Console.WriteLine("Rezultat je: {0}", o.EndInvoke(ref y, ar));
    }
}